REM
REM                           GETADDR.BAS
REM   Copyright (c) 1997, 1998 Anthony E. Greene <agreene@pobox.com>
REM
REM
REM  This QBasic program is designed to read Eudora 1.44 - 3.03 mailbox
REM  (MBX) files and extract addresses. The addresses are then written to
REM  a Eudora Nickname file.
REM
REM
REM  Following are the recognized From Line formats:
REM
REM  1. From: Full Name <user@domain>
REM  2. From: "Full Name" <user@domain>
REM  3. From: user@domain (Full Name)
REM  4. From: <user@domain> (Full Name)
REM  5. From: user@domain
REM  6. From: <user@domain>
REM
REM  Other formats are legal but do not contain sufficient
REM  address information to be useful. <agreene 18-Feb-97>
REM
REM

SetVariables:
version$ = "1.5"
mbxlist$ = "mbxlist.txt"
nosort$ = "nosort.txt"
dupelist$ = "dupelist.txt"
addrlist$ = "addrlist.txt"
alias$ = "alias"
sp$ = " "
tab$ = CHR$(9)
quote$ = CHR$(34)
linectr% = 0
addressctr% = 0
lastaddress$ = ""
progress$ = "|"

MainMenu:
CLS
LOCATE 2, 29: PRINT "Address Extractor v"; version$
LOCATE 3, 20: PRINT "Anthony E. Greene <agreene@pobox.com>"
LOCATE 4, 20: PRINT "---------------------------------------"
LOCATE 15, 20: PRINT "This address will not be included in the"
LOCATE 16, 20: PRINT "final address list."
LOCATE 19, 25: PRINT "[Q] = Quit"
LOCATE 20, 25: PRINT "[*] = Include all Addresses"
myaddress$ = ""
WHILE myaddress$ = ""
 LOCATE 6, 40: PRINT SPACE$(39)
 LOCATE 6, 20: LINE INPUT "Your Email Address: ", myaddress$
WEND
IF UCASE$(myaddress$) = "Q" THEN CLS : SYSTEM
LOCATE 15: PRINT SPACE$(79)
LOCATE 16: PRINT SPACE$(79)
LOCATE 20: PRINT SPACE$(79)
LOCATE 20, 25: PRINT "[T]ab Delimited"
LOCATE 21, 25: PRINT "[A]ddresses Only"
LOCATE 22, 25: PRINT "[E]udora Address Book Format"
LOCATE 15, 20: PRINT "Addresses will be saved to a"
LOCATE 16, 20: PRINT "file is this format"
outformat$ = ""
WHILE INSTR("TAEQ", outformat$) = 0 OR LEN(outformat$) > 1 OR outformat$ = ""
 LOCATE 7, 40: PRINT SPACE$(39)
 LOCATE 7, 18: LINE INPUT "Select Output Format: ", outformat$
 outformat$ = UCASE$(outformat$)
WEND
IF outformat$ = "Q" THEN CLS : SYSTEM
LOCATE 15: PRINT SPACE$(79)
LOCATE 16: PRINT SPACE$(79)
LOCATE 19: PRINT SPACE$(79)
LOCATE 20: PRINT SPACE$(79)
LOCATE 21: PRINT SPACE$(79)
LOCATE 22: PRINT SPACE$(79)


OpenMailboxList:
OPEN nosort$ FOR OUTPUT AS #3
OPEN mbxlist$ FOR INPUT AS #1
LOCATE 10, 2: PRINT "Processing Mailbox:"
LOCATE 15, 32: PRINT "Working..."
DO
 LINE INPUT #1, mailbox$
 OPEN mailbox$ FOR INPUT AS #2
 LOCATE 10, 23: PRINT SPACE$(56)
 LOCATE 10, 23: PRINT mailbox$
 GOSUB ReadMailbox
 CLOSE #2
LOOP WHILE NOT EOF(1)
CLOSE #1
CLOSE #3


SortAddresses:
LOCATE 10, 21: PRINT SPACE$(58)
LOCATE 15: PRINT SPACE$(79)
LOCATE 11: PRINT SPACE$(79)
LOCATE 10: PRINT "Sorting addresses..."
SHELL "sort < " + nosort$ + " > " + dupelist$


DeleteDupes:
OPEN dupelist$ FOR INPUT AS #4
OPEN addrlist$ FOR OUTPUT AS #5
lastalias$ = ""
addressctr% = 0
LOCATE 10: PRINT SPACE$(79)
LOCATE 11, 19: PRINT SPACE$(60)
LOCATE 10: PRINT "Deleting Dupes..."
WHILE NOT EOF(4)
 LINE INPUT #4, aliasline$
 IF UCASE$(aliasline$) <> UCASE$(lastalias$) THEN
  PRINT #5, aliasline$
  addressctr% = addressctr% + 1
  LOCATE 11: PRINT addressctr%; "Unique addresses..."
 END IF
 lastalias$ = aliasline$
WEND


CloseProgram:
CLOSE #4
CLOSE #5
KILL nosort$
KILL dupelist$
KILL mbxlist$
LOCATE 10: PRINT SPACE$(79)
LOCATE 10: PRINT "Done."
LOCATE 11: PRINT SPACE$(79)
LOCATE 11: PRINT addressctr%; "Unique addresses saved in file "; UCASE$(addrlist$)
PRINT
PRINT
SYSTEM


ReadMailbox:
WHILE NOT EOF(2)
 LINE INPUT #2, fromline$
 IF LEFT$(fromline$, 6) = "From: " AND INSTR(fromline$, "@") > 0 AND (INSTR(fromline$, myaddress$) = 0 OR myaddress$ = "*") AND INSTR(fromline$, "From:  ") = 0 THEN
  GOSUB ProcessFromLine
  GOSUB ExtractUserData
  GOSUB WriteNickname
 END IF
 linectr% = linectr% + 1
 IF linectr% = 500 THEN
  GOSUB ProgressMeter
  linectr% = 0
 END IF
WEND
RETURN

ProcessFromLine:
 from$ = LTRIM$(RTRIM$(MID$(fromline$, 7, LEN(fromline$) - 6)))
 IF LEFT$(from$, 1) = quote$ THEN fromformat% = 2: RETURN
 IF LEFT$(from$, 1) = "<" THEN
  IF INSTR(from$, "(") > 0 THEN
   fromformat% = 4
  ELSE
   fromformat% = 6
  END IF
  RETURN
 END IF
 IF INSTR(from$, "<") > 0 THEN fromformat% = 1: RETURN
 IF INSTR(from$, "(") > 0 THEN fromformat% = 3: RETURN
 fromformat% = 5
RETURN

ExtractUserData:
 SELECT CASE fromformat%
  CASE 1
   nameend% = INSTR(from$, "<") - 2
   IF nameend% > 1 THEN FullName$ = LTRIM$(RTRIM$(LEFT$(from$, nameend%))) ELSE FullName$ = "No Name"
   EmailAddress$ = LTRIM$(RTRIM$(MID$(from$, nameend% + 3, LEN(from$) - (nameend% + 3))))
  CASE 2
   nameend% = INSTR(2, from$, quote$) - 1
   IF nameend% > 1 THEN FullName$ = LTRIM$(RTRIM$(MID$(from$, 2, nameend% - 1))) ELSE FullName$ = "No Name"
   EmailAddress$ = LTRIM$(RTRIM$(MID$(from$, nameend% + 4, LEN(from$) - (nameend% + 4))))
  CASE 3
   namestart% = INSTR(from$, "(") + 1
   FullName$ = LTRIM$(RTRIM$(MID$(from$, namestart%, LEN(from$) - namestart%)))
   EmailAddress$ = RTRIM$(LEFT$(from$, namestart% - 3))
  CASE 4
   namestart% = INSTR(from$, "(") + 1
   FullName$ = LTRIM$(RTRIM$(MID$(from$, namestart%, LEN(from$) - namestart%)))
   EmailAddress$ = LTRIM$(RTRIM$(MID$(from$, 2, namestart% - 5)))
  CASE 5
   FullName$ = LTRIM$(RTRIM$(from$))
   EmailAddress$ = FullName$
  CASE 6
   FullName$ = LTRIM$(RTRIM$(MID$(from$, 2, LEN(from$) - 2)))
   EmailAddress$ = LTRIM$(RTRIM$(MID$(from$, 2, LEN(from$) - 2)))
 END SELECT
RETURN

WriteNickname:
IF UCASE$(EmailAddress$) <> UCASE$(lastaddress$) AND INSTR(FullName$, quote$) = 0 THEN
 SELECT CASE outformat$
  CASE "T"
   PRINT #3, FullName$; tab$; EmailAddress$
  CASE "A"
   PRINT #3, EmailAddress$
  CASE "E"
   PRINT #3, alias$; sp$; quote$; FullName$; quote$; sp$; EmailAddress$
 END SELECT
 addressctr% = addressctr% + 1
 LOCATE 11, 1: PRINT "Addresses Extracted: "; addressctr%
END IF
lastaddress$ = EmailAddress$
RETURN

ProgressMeter:
 SELECT CASE progress$
  CASE "|"
   progress$ = "/"
  CASE "/"
   progress$ = "-"
  CASE "-"
   progress$ = "\"
  CASE "\"
   progress$ = "|"
 END SELECT
 LOCATE 15, 43: PRINT progress$
RETURN

